From: Victor Seva <linuxmaniac@torreviejawireless.org>
Date: Fri, 3 Jan 2020 14:02:36 +0100
Subject: oneshot: let the OS choose a free port

---
 samples/oneshot/client.lua | 4 +++-
 samples/oneshot/server.lua | 4 +++-
 test.sh                    | 9 ++++++---
 3 files changed, 12 insertions(+), 5 deletions(-)

diff --git a/samples/oneshot/client.lua b/samples/oneshot/client.lua
index 48bc0bb..b652698 100644
--- a/samples/oneshot/client.lua
+++ b/samples/oneshot/client.lua
@@ -15,7 +15,9 @@ local params = {
 }
 
 local peer = socket.tcp()
-peer:connect("127.0.0.1", 8888)
+local port = 8888
+if arg[1] then port = arg[1] end
+peer:connect("127.0.0.1", port)
 
 -- [[ SSL wrapper
 peer = assert( ssl.wrap(peer, params) )
diff --git a/samples/oneshot/server.lua b/samples/oneshot/server.lua
index b3bcd8d..0952986 100644
--- a/samples/oneshot/server.lua
+++ b/samples/oneshot/server.lua
@@ -21,7 +21,9 @@ local ctx = assert(ssl.newcontext(params))
 
 local server = socket.tcp()
 server:setoption('reuseaddr', true)
-assert( server:bind("127.0.0.1", 8888) )
+assert( server:bind("127.0.0.1", 0) )
+local ip, port = server:getsockname()
+io.stderr:write(port)
 server:listen()
 
 local peer = server:accept()
diff --git a/test.sh b/test.sh
index dbb2e1c..b6b5d43 100644
--- a/test.sh
+++ b/test.sh
@@ -5,10 +5,13 @@ set -x
 set -m
 
 cd samples/oneshot/
-
-lua$1 server.lua &
+port_file=$(mktemp)
+lua$1 server.lua 2>${port_file} &
 sleep 1
 ret=0
-lua$1 client.lua || ret=$?
+port=$(cat ${port_file})
+echo "server port is: $port"
+lua$1 client.lua $port || ret=$?
 kill -9 %1 || true
+rm -f ${port_file}
 exit $ret
